using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace can
{
    // 豸ͺ
    public enum DEV_TYPE {
        VCI_PCI5121 = 1,
        VCI_PCI9810 = 2,
        VCI_USBCAN1 = 3,
        VCI_USBCAN2 = 4,
        VCI_USBCAN2A = 4,
        VCI_PCI9820 = 5,
        VCI_CAN232 = 6,
        VCI_PCI5110 = 7,
        VCI_CANLITE = 8,
        VCI_ISA9620 = 9,
        VCI_ISA5420 = 10,
        VCI_PC104CAN = 11,
        VCI_CANETE = 12,
        VCI_DNP9810 = 13,
        VCI_PCI9840 = 14,
        VCI_PC104CAN2 = 15,
        VCI_PCI9820I = 16,
        VCI_PEC9920 = 18,
        VCI_CANETTCP = 17,
        VCI_PCI5010U = 19,
        VCI_USBCANEU = 20,
        VCI_USBCAN2EU = 21,
    };

    // CAN
    public enum CAN_ERR {
        ERR_CAN_OVERFLOW = 0x0001, //CANڲFIFO
        ERR_CAN_ERRALARM = 0x0002, //CAN󱨾
        ERR_CAN_PASSIVE = 0x0004, //CAN
        ERR_CAN_LOSE = 0x0008, //CANٲöʧ
        ERR_CAN_BUSERR = 0x0010, //CANߴ
        ERR_CAN_BUSCLOSE = 0x0020, //CAN߹ر
    };

    // ͨô
    public enum DEV_ERR {
        ERR_DEVICEOPENED = 0x0100, //豸Ѿ
        ERR_DEVICEOPEN = 0x0200, //豸
        ERR_DEVICENOTOPEN = 0x0400, //豸ûд
        ERR_BUFFEROVERFLOW = 0x0800, //
        ERR_DEVICENOTEXIST = 0x1000, //豸
        ERR_LOADKERNELDLL = 0x2000, //װض̬ʧ
        ERR_CMDFAILED = 0x4000, //ִʧܴ
        ERR_BUFFERCREATE = 0x8000, //ڴ治
    };

    // ÷״ֵ̬
    public enum STATUS {
        STATUS_OK = 1,
        STATUS_ERR = 0,
    };

    // ÷״ֵ̬
    public enum CMD {
        CMD_DESIP = 0, 
        CMD_DESPORT = 1, 
        CMD_CHGDESIPANDPORT = 2, 
    };

    public enum REF {
        REFERENCE_BAUD = 1,
        REFERENCE_SET_TRANSMIT_TIMEOUT = 2,
        REFERENCE_ADD_FILTER = 3,
        REFERENCE_SET_FILTER = 4, 
    };

    // 1.ZLGCANϵнӿڿϢ
    unsafe public struct VCI_BOARD_INFO {
        public ushort hw_Version;
        public ushort fw_Version;
        public ushort dr_Version;
        public ushort in_Version;
        public ushort irq_Num;
        public byte can_Num;
        public fixed byte str_Serial_Num[20];
        public fixed byte str_hw_Type[40];
        public fixed ushort Reserved[4];
    };

    // 2.CANϢ֡
    unsafe public struct VCI_CAN_OBJ {
        public uint ID;
        public uint TimeStamp;
        public byte TimeFlag;
        public byte SendType;
        public byte RemoteFlag;
        public byte ExternFlag;
        public byte DataLen;
        public fixed byte Data[8];
        public fixed byte Reserved[3];
    };

    // 3.CAN״̬
    unsafe public struct VCI_CAN_STATUS {
        public byte ErrInterrupt;
        public byte regMode;
        public byte regStatus;
        public byte regALCapture;
        public byte regECCapture;
        public byte regEWLimit;
        public byte regRECounter;
        public byte regTECounter;
        public uint Reserved;
    };

    // 4.Ϣ
    unsafe public struct VCI_ERR_INFO {
        public uint ErrCode;
        public fixed byte Passive_ErrData[3];
        public byte ArLost_ErrData;
    };

    // 5.ʼCAN
    unsafe public struct VCI_INIT_CONFIG {
        public uint AccCode;
        public uint AccMask;
        public uint Reserved;
        public byte Filter;
        public byte Timing0;
        public byte Timing1;
        public byte Mode;
    };

    unsafe public struct CHGDESIPANDPORT {
        public fixed byte szpwd[10];
        public fixed byte szdesip[20];
        public int desport;
    };

    unsafe public struct VCI_FILTER_RECORD {
        public uint ExtFrame;
        public uint Start;
        public uint End;
    };

    unsafe public partial class API {
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_OpenDevice(uint DeviceType,uint DeviceInd,uint Reserved);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_CloseDevice(uint DeviceType,uint DeviceInd);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_InitCAN(uint DeviceType, uint DeviceInd, uint CANInd,VCI_INIT_CONFIG *pInitConfig);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_ReadBoardInfo(uint DeviceType,uint DeviceInd,VCI_BOARD_INFO *pInfo);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_ReadErrInfo(uint DeviceType,uint DeviceInd,uint CANInd,VCI_ERR_INFO *pErrInfo);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_ReadCANStatus(uint DeviceType,uint DeviceInd,uint CANInd,VCI_CAN_STATUS *pCANStatus);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_GetReference(uint DeviceType,uint DeviceInd,uint CANInd,uint RefType,void *pData);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_SetReference(uint DeviceType,uint DeviceInd,uint CANInd,uint RefType,void *pData);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_GetReceiveNum(uint DeviceType,uint DeviceInd,uint CANInd);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_ClearBuffer(uint DeviceType,uint DeviceInd,uint CANInd);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_StartCAN(uint DeviceType,uint DeviceInd,uint CANInd);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_ResetCAN(uint DeviceType,uint DeviceInd,uint CANInd);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_Transmit(uint DeviceType,uint DeviceInd,uint CANInd,VCI_CAN_OBJ *pSend,uint Len);
        //[DllImport("controlcan.dll")]
        [DllImport("CANETE.dll")]
        public static extern uint VCI_Receive(uint DeviceType,uint DeviceInd,uint CANInd,VCI_CAN_OBJ *pReceive,uint Len,int WaitTime);
    }
}

